package com.siit.wfw.frame.service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.siit.wfw.frame.client.FrameSiitFormClient;
import com.siit.wfw.frame.configs.dynamicdatasource.DataSource;
import com.siit.wfw.frame.dao.BaseNativeSqlRepository;
import com.siit.wfw.frame.dto.LoginVo;
import com.siit.wfw.frame.po.FourCheckDetailPO;
import com.siit.wfw.frame.utils.ConfigUtils;
import com.siit.wfw.frame.utils.Convert;
import com.siit.wfw.frame.utils.FileTypeUtil;
import com.siit.wfw.frame.utils.SIITDBType;
import com.siit.wfw.frame.utils.SpringContextUtils;
import com.siit.wfw.frame.utils.UserTools;
import com.siit.wfw.frame.viewvo.BizOutput;
import com.siit.wfw.frame.viewvo.PageView;
import java.io.File;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Map.Entry;
import javax.annotation.Resource;
import org.apache.commons.io.FileUtils;
import org.springframework.stereotype.Service;

@Service
public class FourCheckService {

   private static final String[] defaultSuccess = new String[]{"GD-2-8", "GD-2-7", "GD-3-4", "GD-1-13", "GD-1-12", "GD-1-14", "GD-2-1", "GD-2-11", "GD-2-9"};
   private static final String[] fileDefaultSuccess = new String[]{"GD-1-11", "GD-2-6", "GD-2-2", "GD-3-6", "GD-3-4", "GD-3-3", "GD-4-3", "GD-4-4", "GD-3-8"};
   @Resource
   private FrameSiitFormClient frameSiitFormClient;
   @Resource
   private BaseNativeSqlRepository baseNativeSqlRepository;
   @Resource
   private ConfigUtils configUtils;


   public static boolean containsSpecialChars(String str) {
      if(Convert.isNullOrEmpty(str).booleanValue()) {
         return false;
      } else {
         byte[] bs = str.getBytes(StandardCharsets.UTF_8);
         return (bs[0] > 176 || bs[0] < 247) && bs.length > 1 && bs[1] <= 161 && bs[1] >= 254;
      }
   }

   public static void main(String[] args) {
      ArrayList enumList = new ArrayList();
      enumList.add("1");
      enumList.add("2");
      enumList.add("3");
      HashMap aa = new HashMap();
      aa.put("1", "1");
      aa.put("2", "2");
      System.out.println(enumList.contains(Convert.toReadStr(aa.get("1"))));
   }

   @DataSource("siitarct")
   public BizOutput saveBookFourCheckInfo(Map inputval, JSONObject forminfo, String sourcekey, String bookformuuid) throws Exception {
      if(!"1".equals(forminfo.getString("isFourCheck"))) {
         return BizOutput.success();
      } else {
         HashMap resultMap = new HashMap();
         JSONArray errorArray = new JSONArray();
         resultMap.put("GD-3-2", "1");
         resultMap.put("GD-3-1", "1");
         resultMap.put("GD-2-3", "1");
         resultMap.put("GD-1-5", "1");
         resultMap.put("GD-1-4", "1");
         resultMap.put("GD-1-7", "1");
         resultMap.put("GD-1-8", "1");
         resultMap.put("GD-1-3", "1");
         resultMap.put("GD-2-4", "1");
         resultMap.put("GD-1-2", "1");
         resultMap.put("GD-1-6", "1");
         String taskUuid = this.getProxy().saveBookFourCheckTask(inputval, forminfo, "0");
         this.getProxy().updateDefaultSuccess(taskUuid, defaultSuccess);
         HashMap enumMap = new HashMap();
         BizOutput columnEnum = this.frameSiitFormClient.queryBookByViewSourceKey(sourcekey);
         JSONArray detailPO;
         if(columnEnum.isStatus() && columnEnum.getData() != null) {
            detailPO = JSONObject.parseArray(JSON.toJSONString(columnEnum.getData()));
            if(detailPO != null && detailPO.size() > 0) {
               for(int flag = 0; flag < detailPO.size(); ++flag) {
                  JSONObject formtypecolumnMap = detailPO.getJSONObject(flag);
                  String allColumnBiz = Convert.toReadStr(formtypecolumnMap.get("columnuuid"));
                  if(enumMap.containsKey(allColumnBiz)) {
                     List isUnique = (List)enumMap.get(allColumnBiz);
                     isUnique.add(Convert.toReadStr(formtypecolumnMap.get("saveval")));
                  } else {
                     ArrayList var25 = new ArrayList();
                     var25.add(Convert.toReadStr(formtypecolumnMap.get("saveval")));
                     enumMap.put(allColumnBiz, var25);
                  }
               }
            }
         }

         detailPO = null;
         StringBuffer var22 = new StringBuffer(Convert.toReadStr(inputval.get("BOOK_CODE")));
         HashMap var23 = new HashMap();
         BizOutput var24 = this.frameSiitFormClient.queryBookColumnListByInput(bookformuuid, sourcekey);
         JSONObject errorMsg;
         JSONObject errorObject;
         JSONObject errorObject1;
         FourCheckDetailPO var21;
         if(var24.isStatus() && var24.getData() != null) {
            JSONArray var26 = JSONObject.parseArray(JSON.toJSONString(var24.getData()));
            if(var26 != null && var26.size() > 0) {
               for(int error = 0; error < var26.size(); ++error) {
                  errorMsg = var26.getJSONObject(error);
                  Object[] i = new Object[]{errorMsg.get("columnname"), errorMsg.get("collength"), "0".equals(errorMsg.get("isNull"))?"Y":"N", errorMsg.get("columntip"), errorMsg.get("datatype"), errorMsg.get("remark"), errorMsg.get("isUniqueCheck")};
                  var23.put(Convert.toReadStr(errorMsg.get("columnname")), i);
                  if("1".equals(errorMsg.get("isNull")) && !inputval.containsKey(i[0])) {
                     var21 = new FourCheckDetailPO();
                     var21.setTabuuid(Convert.getUUID());
                     var21.setChecktaskuuid(taskUuid);
                     var21.setXmlflag(Convert.toReadStr(inputval.get("BOOK_CODE")));
                     var21.setXmlcolumn(Convert.toReadStr(errorMsg.get("columntip")) + "为空");
                     var21.setCreatetime(new Date());
                     var21.setChecknumber("GD-2-3");
                     this.baseNativeSqlRepository.saveAndFlush(var21);
                     resultMap.put("GD-2-3", "2");
                     errorObject = new JSONObject();
                     errorObject.put("checknumber", "GD-2-3");
                     errorObject.put("xmlcolumn", Convert.toReadStr(errorMsg.get("columntip")) + "为空");
                     errorArray.add(errorObject);
                  }

                  if(enumMap.containsKey(Convert.toReadStr(errorMsg.get("tabuuid")))) {
                     List var35 = (List)enumMap.get(Convert.toReadStr(errorMsg.get("tabuuid")));
                     if(!var35.contains(Convert.toReadStr(inputval.get(i[0]))) && (!"0".equals(errorMsg.get("isNull")) || !Convert.isNullOrEmpty(inputval.get(i[0])).booleanValue())) {
                        var21 = new FourCheckDetailPO();
                        var21.setTabuuid(Convert.getUUID());
                        var21.setChecktaskuuid(taskUuid);
                        var21.setXmlflag(Convert.toReadStr(inputval.get("BOOK_CODE")));
                        var21.setXmlcolumn(Convert.toReadStr(errorMsg.get("columntip")) + "不在允许的值域内");
                        var21.setXmlcolumn1(Convert.toReadStr(inputval.get(i[0])));
                        var21.setXmlcolumn2(String.join(", ", var35));
                        var21.setCreatetime(new Date());
                        var21.setChecknumber("GD-1-4");
                        this.baseNativeSqlRepository.saveAndFlush(var21);
                        var21 = new FourCheckDetailPO();
                        var21.setTabuuid(Convert.getUUID());
                        var21.setChecktaskuuid(taskUuid);
                        var21.setXmlflag(Convert.toReadStr(inputval.get("BOOK_CODE")));
                        var21.setXmlcolumn(Convert.toReadStr(errorMsg.get("columntip")) + "不在允许的值域内");
                        var21.setXmlcolumn1(Convert.toReadStr(inputval.get(i[0])));
                        var21.setXmlcolumn2(String.join(", ", var35));
                        var21.setCreatetime(new Date());
                        var21.setChecknumber("GD-1-5");
                        this.baseNativeSqlRepository.saveAndFlush(var21);
                        JSONObject childmap = new JSONObject();
                        childmap.put("checknumber", "GD-1-5");
                        childmap.put("xmlcolumn", Convert.toReadStr(errorMsg.get("columntip")) + "不在允许的值域内[" + String.join(", ", var35) + "]");
                        errorArray.add(childmap);
                        errorObject1 = new JSONObject();
                        errorObject1.put("checknumber", "GD-1-4");
                        errorObject1.put("xmlcolumn", Convert.toReadStr(errorMsg.get("columntip")) + "不在允许的值域内[" + String.join(", ", var35) + "]");
                        errorArray.add(errorObject1);
                        resultMap.put("GD-1-5", "2");
                        resultMap.put("GD-1-4", "2");
                     }
                  }
               }
            }
         }

         boolean var27 = this.getProxy().checkBookUnique(Convert.toReadStr(inputval.get("BOOK_CODE")));
         if(!var27) {
            var21 = new FourCheckDetailPO();
            var21.setTabuuid(Convert.getUUID());
            var21.setChecktaskuuid(taskUuid);
            var21.setXmlflag(Convert.toReadStr(inputval.get("BOOK_CODE")));
            var21.setXmlcolumn(var22.toString() + "已经在系统中存在");
            var21.setCreatetime(new Date());
            var21.setChecknumber("GD-1-7");
            this.baseNativeSqlRepository.saveAndFlush(var21);
            var21 = new FourCheckDetailPO();
            var21.setTabuuid(Convert.getUUID());
            var21.setChecktaskuuid(taskUuid);
            var21.setXmlflag(Convert.toReadStr(inputval.get("BOOK_CODE")));
            var21.setXmlcolumn(var22.toString() + "已经在系统中存在");
            var21.setCreatetime(new Date());
            var21.setChecknumber("GD-1-8");
            this.baseNativeSqlRepository.saveAndFlush(var21);
            JSONObject var28 = new JSONObject();
            var28.put("checknumber", "GD-1-7");
            var28.put("xmlcolumn", var22.toString() + "已经在系统中存在");
            errorArray.add(var28);
            errorMsg = new JSONObject();
            errorMsg.put("checknumber", "GD-1-8");
            errorMsg.put("xmlcolumn", var22.toString() + "已经在系统中存在");
            errorArray.add(errorMsg);
            resultMap.put("GD-1-7", "2");
            resultMap.put("GD-1-8", "2");
         }

         Iterator var29 = inputval.entrySet().iterator();

         while(var29.hasNext()) {
            Entry var31 = (Entry)var29.next();
            String var33 = (String)var31.getKey();
            Object var36 = var31.getValue();
            if(var23.containsKey(var33)) {
               Object[] var37 = (Object[])var23.get(var33);
               if("N".equals(var37[2]) && Convert.isNullOrEmpty(var36).booleanValue()) {
                  var21 = new FourCheckDetailPO();
                  var21.setTabuuid(Convert.getUUID());
                  var21.setChecktaskuuid(taskUuid);
                  var21.setXmlflag(Convert.toReadStr(inputval.get("BOOK_CODE")));
                  var21.setXmlcolumn(Convert.toReadStr(var37[3]) + "值为空");
                  var21.setCreatetime(new Date());
                  var21.setChecknumber("GD-2-4");
                  this.baseNativeSqlRepository.saveAndFlush(var21);
                  resultMap.put("GD-2-4", "2");
                  errorObject1 = new JSONObject();
                  errorObject1.put("checknumber", "GD-1-7");
                  errorObject1.put("xmlcolumn", Convert.toReadStr(var37[3]) + "值为空");
                  errorArray.add(errorObject1);
               }

               if(Convert.toReadStr(var36).length() > Convert.toInteger(var37[1]).intValue() && !(var36 instanceof Date)) {
                  var21 = new FourCheckDetailPO();
                  var21.setTabuuid(Convert.getUUID());
                  var21.setChecktaskuuid(taskUuid);
                  var21.setXmlflag(Convert.toReadStr(inputval.get("BOOK_CODE")));
                  var21.setXmlcolumn(Convert.toReadStr(var37[3]) + "值超长");
                  var21.setXmlcolumn1(Convert.toReadStr(Integer.valueOf(Convert.toReadStr(var36).length())));
                  var21.setXmlcolumn2(Convert.toReadStr(var37[1]));
                  var21.setCreatetime(new Date());
                  var21.setChecknumber("GD-1-2");
                  this.baseNativeSqlRepository.saveAndFlush(var21);
                  resultMap.put("GD-1-2", "2");
                  errorObject1 = new JSONObject();
                  errorObject1.put("checknumber", "GD-1-7");
                  errorObject1.put("xmlcolumn", Convert.toReadStr(var37[3]) + "值超长");
                  errorArray.add(errorObject1);
               }

               if(!this.checkDataType(Convert.toReadStr(var37[4]), var36)) {
                  var21 = new FourCheckDetailPO();
                  var21.setTabuuid(Convert.getUUID());
                  var21.setChecktaskuuid(taskUuid);
                  var21.setXmlflag(Convert.toReadStr(inputval.get("BOOK_CODE")));
                  var21.setXmlcolumn(Convert.toReadStr(var37[3]) + "值与类型不符");
                  var21.setXmlcolumn1(Convert.toReadStr(var36));
                  var21.setXmlcolumn2(Convert.toReadStr(var37[4]));
                  var21.setCreatetime(new Date());
                  var21.setChecknumber("GD-1-3");
                  this.baseNativeSqlRepository.saveAndFlush(var21);
                  resultMap.put("GD-1-3", "2");
                  errorObject1 = new JSONObject();
                  errorObject1.put("checknumber", "GD-1-7");
                  errorObject1.put("xmlcolumn", Convert.toReadStr(var37[3]) + "值与类型不符");
                  errorArray.add(errorObject1);
               }

               if(containsSpecialChars(Convert.toReadStr(var36))) {
                  var21 = new FourCheckDetailPO();
                  var21.setTabuuid(Convert.getUUID());
                  var21.setChecktaskuuid(taskUuid);
                  var21.setXmlflag(Convert.toReadStr(inputval.get("BOOK_CODE")));
                  var21.setXmlcolumn(Convert.toReadStr(var37[3]) + "值包含特殊字符");
                  var21.setXmlcolumn1(Convert.toReadStr(var36));
                  var21.setCreatetime(new Date());
                  var21.setChecknumber("GD-1-3");
                  this.baseNativeSqlRepository.saveAndFlush(var21);
                  resultMap.put("GD-1-6", "2");
                  errorObject1 = new JSONObject();
                  errorObject1.put("checknumber", "GD-1-7");
                  errorObject1.put("xmlcolumn", Convert.toReadStr(var37[3]) + "值包含特殊字符");
                  errorArray.add(errorObject1);
               }
            }
         }

         this.getProxy().updateFourCheckTaskStatus(taskUuid, resultMap);
         if(!resultMap.containsValue("2")) {
            return BizOutput.success();
         } else {
            BizOutput var30 = new BizOutput();
            var30.setStatus(false);
            StringBuffer var32 = new StringBuffer();

            for(int var34 = 0; var34 < errorArray.size(); ++var34) {
               errorObject = errorArray.getJSONObject(var34);
               var32.append(errorObject.get("checknumber") + ":" + errorObject.getString("xmlcolumn")).append(";");
            }

            var30.setErrorMessage("四性检测失败:\n" + var32.toString());
            return var30;
         }
      }
   }

   @DataSource("siitarct")
   public boolean checkBookUnique(String bookCode) throws Exception {
      StringBuffer sql = new StringBuffer();
      sql.append("SELECT * FROM ").append("TB_BOOK_INFO").append(" WHERE BOOK_CODE = :bookCode");
      HashMap params = new HashMap();
      params.put("bookCode", bookCode);
      List list = this.baseNativeSqlRepository.querySqlList(sql.toString(), params);
      return list.size() <= 0;
   }

   @DataSource("siitarct")
   public BizOutput saveFourCheckInfo(Map inputval, JSONObject forminfo, String sourcekey, String checktype, boolean isCheck) throws Exception {
      if(!"1".equals(forminfo.getString("isFourCheck"))) {
         return BizOutput.success();
      } else {
         HashMap resultMap = new HashMap();
         JSONArray errorArray = new JSONArray();
         resultMap.put("GD-3-2", "1");
         resultMap.put("GD-3-1", "1");
         resultMap.put("GD-2-3", "1");
         resultMap.put("GD-1-5", "1");
         resultMap.put("GD-1-4", "1");
         resultMap.put("GD-1-7", "1");
         resultMap.put("GD-1-8", "1");
         resultMap.put("GD-1-3", "1");
         resultMap.put("GD-2-4", "1");
         resultMap.put("GD-1-2", "1");
         resultMap.put("GD-1-6", "1");
         String taskUuid = this.getProxy().saveFourCheckTask(inputval, forminfo, checktype);
         this.getProxy().updateDefaultSuccess(taskUuid, defaultSuccess);
         HashMap enumMap = new HashMap();
         BizOutput columnEnum = this.frameSiitFormClient.queryByViewSourceKey(sourcekey);
         JSONArray detailPO;
         if(columnEnum.isStatus() && columnEnum.getData() != null) {
            detailPO = JSONObject.parseArray(JSON.toJSONString(columnEnum.getData()));
            if(detailPO != null && detailPO.size() > 0) {
               for(int flag = 0; flag < detailPO.size(); ++flag) {
                  JSONObject uniqueColumn = detailPO.getJSONObject(flag);
                  String formtypecolumnMap = Convert.toReadStr(uniqueColumn.get("columnuuid"));
                  if(enumMap.containsKey(formtypecolumnMap)) {
                     List allColumnBiz = (List)enumMap.get(formtypecolumnMap);
                     allColumnBiz.add(Convert.toReadStr(uniqueColumn.get("saveval")));
                  } else {
                     ArrayList var27 = new ArrayList();
                     var27.add(Convert.toReadStr(uniqueColumn.get("saveval")));
                     enumMap.put(formtypecolumnMap, var27);
                  }
               }
            }
         }

         detailPO = null;
         StringBuffer var24 = new StringBuffer();
         ArrayList var25 = new ArrayList();
         HashMap var26 = new HashMap();
         BizOutput var28 = this.frameSiitFormClient.findFormAllColumnByuuid(Convert.toReadStr(forminfo.getString("tabuuid")));
         JSONObject errorMsg;
         JSONObject errorObject;
         JSONObject errorObject1;
         FourCheckDetailPO var23;
         if(var28.isStatus() && var28.getData() != null) {
            JSONArray isUnique = JSONObject.parseArray(JSON.toJSONString(var28.getData()));
            if(isUnique != null && isUnique.size() > 0) {
               for(int error = 0; error < isUnique.size(); ++error) {
                  errorMsg = isUnique.getJSONObject(error);
                  Object[] i = new Object[]{errorMsg.get("columnname"), errorMsg.get("collength"), "0".equals(errorMsg.get("isNull"))?"Y":"N", errorMsg.get("columntip"), errorMsg.get("datatype"), errorMsg.get("remark"), errorMsg.get("isUniqueCheck")};
                  var26.put(Convert.toReadStr(errorMsg.get("columnname")), i);
                  if("1".equals(Convert.toReadStr(errorMsg.get("isUniqueCheck")))) {
                     var25.add(Convert.toReadStr(errorMsg.get("columnname")));
                     var24.append(Convert.toReadStr(errorMsg.get("remark"))).append(":").append(inputval.get(Convert.toReadStr(errorMsg.get("columnname")))).append(";");
                  }

                  if("1".equals(errorMsg.get("isNull")) && !inputval.containsKey(i[0])) {
                     var23 = new FourCheckDetailPO();
                     var23.setTabuuid(Convert.getUUID());
                     var23.setChecktaskuuid(taskUuid);
                     var23.setXmlflag(Convert.toReadStr(inputval.get("BARCODE")));
                     var23.setXmlcolumn(Convert.toReadStr(errorMsg.get("columntip")) + "为空");
                     var23.setCreatetime(new Date());
                     var23.setChecknumber("GD-2-3");
                     this.baseNativeSqlRepository.saveAndFlush(var23);
                     resultMap.put("GD-2-3", "2");
                     errorObject = new JSONObject();
                     errorObject.put("checknumber", "GD-2-3");
                     errorObject.put("xmlcolumn", Convert.toReadStr(errorMsg.get("columntip")) + "为空");
                     errorArray.add(errorObject);
                  }

                  if(enumMap.containsKey(Convert.toReadStr(errorMsg.get("tabuuid")))) {
                     List var38 = (List)enumMap.get(Convert.toReadStr(errorMsg.get("tabuuid")));
                     if(!var38.contains(Convert.toReadStr(inputval.get(i[0]))) && (!"0".equals(errorMsg.get("isNull")) || !Convert.isNullOrEmpty(inputval.get(i[0])).booleanValue())) {
                        var23 = new FourCheckDetailPO();
                        var23.setTabuuid(Convert.getUUID());
                        var23.setChecktaskuuid(taskUuid);
                        var23.setXmlflag(Convert.toReadStr(inputval.get("BARCODE")));
                        var23.setXmlcolumn(Convert.toReadStr(errorMsg.get("columntip")) + "不在允许的值域内");
                        var23.setXmlcolumn1(Convert.toReadStr(inputval.get(i[0])));
                        var23.setXmlcolumn2(String.join(", ", var38));
                        var23.setCreatetime(new Date());
                        var23.setChecknumber("GD-1-4");
                        this.baseNativeSqlRepository.saveAndFlush(var23);
                        var23 = new FourCheckDetailPO();
                        var23.setTabuuid(Convert.getUUID());
                        var23.setChecktaskuuid(taskUuid);
                        var23.setXmlflag(Convert.toReadStr(inputval.get("BARCODE")));
                        var23.setXmlcolumn(Convert.toReadStr(errorMsg.get("columntip")) + "不在允许的值域内");
                        var23.setXmlcolumn1(Convert.toReadStr(inputval.get(i[0])));
                        var23.setXmlcolumn2(String.join(", ", var38));
                        var23.setCreatetime(new Date());
                        var23.setChecknumber("GD-1-5");
                        this.baseNativeSqlRepository.saveAndFlush(var23);
                        JSONObject childmap = new JSONObject();
                        childmap.put("checknumber", "GD-1-5");
                        childmap.put("xmlcolumn", Convert.toReadStr(errorMsg.get("columntip")) + "不在允许的值域内[" + String.join(", ", var38) + "]");
                        errorArray.add(childmap);
                        errorObject1 = new JSONObject();
                        errorObject1.put("checknumber", "GD-1-4");
                        errorObject1.put("xmlcolumn", Convert.toReadStr(errorMsg.get("columntip")) + "不在允许的值域内[" + String.join(", ", var38) + "]");
                        errorArray.add(errorObject1);
                        resultMap.put("GD-1-5", "2");
                        resultMap.put("GD-1-4", "2");
                     }
                  }
               }
            }
         }

         if(isCheck) {
            var23 = new FourCheckDetailPO();
            var23.setTabuuid(Convert.getUUID());
            var23.setChecktaskuuid(taskUuid);
            var23.setXmlflag(Convert.toReadStr(inputval.get("BARCODE")));
            var23.setXmlcolumn("卷内目录的保管期限与案卷目录不一致");
            var23.setCreatetime(new Date());
            var23.setChecknumber("GD-1-5");
            this.baseNativeSqlRepository.saveAndFlush(var23);
            JSONObject var29 = new JSONObject();
            var29.put("checknumber", "GD-1-5");
            var29.put("xmlcolumn", "卷内目录的保管期限与案卷目录不一致");
            errorArray.add(var29);
            resultMap.put("GD-1-5", "2");
         }

         boolean var30 = this.getProxy().checkUnique(inputval, Convert.toReadStr(forminfo.getString("tablename")), var25);
         if(!var30) {
            var23 = new FourCheckDetailPO();
            var23.setTabuuid(Convert.getUUID());
            var23.setChecktaskuuid(taskUuid);
            var23.setXmlflag(Convert.toReadStr(inputval.get("BARCODE")));
            var23.setXmlcolumn(var24.toString() + "已经在系统中存在");
            var23.setCreatetime(new Date());
            var23.setChecknumber("GD-1-7");
            this.baseNativeSqlRepository.saveAndFlush(var23);
            var23 = new FourCheckDetailPO();
            var23.setTabuuid(Convert.getUUID());
            var23.setChecktaskuuid(taskUuid);
            var23.setXmlflag(Convert.toReadStr(inputval.get("BARCODE")));
            var23.setXmlcolumn(var24.toString() + "已经在系统中存在");
            var23.setCreatetime(new Date());
            var23.setChecknumber("GD-1-8");
            this.baseNativeSqlRepository.saveAndFlush(var23);
            JSONObject var31 = new JSONObject();
            var31.put("checknumber", "GD-1-7");
            var31.put("xmlcolumn", var24.toString() + "已经在系统中存在");
            errorArray.add(var31);
            errorMsg = new JSONObject();
            errorMsg.put("checknumber", "GD-1-8");
            errorMsg.put("xmlcolumn", var24.toString() + "已经在系统中存在");
            errorArray.add(errorMsg);
            resultMap.put("GD-1-7", "2");
            resultMap.put("GD-1-8", "2");
         }

         Iterator var32 = inputval.entrySet().iterator();

         while(var32.hasNext()) {
            Entry var34 = (Entry)var32.next();
            String var36 = (String)var34.getKey();
            Object var39 = var34.getValue();
            if(var26.containsKey(var36)) {
               Object[] var40 = (Object[])var26.get(var36);
               if("N".equals(var40[2]) && Convert.isNullOrEmpty(var39).booleanValue()) {
                  var23 = new FourCheckDetailPO();
                  var23.setTabuuid(Convert.getUUID());
                  var23.setChecktaskuuid(taskUuid);
                  var23.setXmlflag(Convert.toReadStr(inputval.get("BARCODE")));
                  var23.setXmlcolumn(Convert.toReadStr(var40[3]) + "值为空");
                  var23.setCreatetime(new Date());
                  var23.setChecknumber("GD-2-4");
                  this.baseNativeSqlRepository.saveAndFlush(var23);
                  resultMap.put("GD-2-4", "2");
                  errorObject1 = new JSONObject();
                  errorObject1.put("checknumber", "GD-1-7");
                  errorObject1.put("xmlcolumn", Convert.toReadStr(var40[3]) + "值为空");
                  errorArray.add(errorObject1);
               }

               if(Convert.toReadStr(var39).length() > Convert.toInteger(var40[1]).intValue() && !(var39 instanceof Date)) {
                  var23 = new FourCheckDetailPO();
                  var23.setTabuuid(Convert.getUUID());
                  var23.setChecktaskuuid(taskUuid);
                  var23.setXmlflag(Convert.toReadStr(inputval.get("BARCODE")));
                  var23.setXmlcolumn(Convert.toReadStr(var40[3]) + "值超长");
                  var23.setXmlcolumn1(Convert.toReadStr(Integer.valueOf(Convert.toReadStr(var39).length())));
                  var23.setXmlcolumn2(Convert.toReadStr(var40[1]));
                  var23.setCreatetime(new Date());
                  var23.setChecknumber("GD-1-2");
                  this.baseNativeSqlRepository.saveAndFlush(var23);
                  resultMap.put("GD-1-2", "2");
                  errorObject1 = new JSONObject();
                  errorObject1.put("checknumber", "GD-1-7");
                  errorObject1.put("xmlcolumn", Convert.toReadStr(var40[3]) + "值超长");
                  errorArray.add(errorObject1);
               }

               if(!this.checkDataType(Convert.toReadStr(var40[4]), var39)) {
                  var23 = new FourCheckDetailPO();
                  var23.setTabuuid(Convert.getUUID());
                  var23.setChecktaskuuid(taskUuid);
                  var23.setXmlflag(Convert.toReadStr(inputval.get("BARCODE")));
                  var23.setXmlcolumn(Convert.toReadStr(var40[3]) + "值与类型不符");
                  var23.setXmlcolumn1(Convert.toReadStr(var39));
                  var23.setXmlcolumn2(Convert.toReadStr(var40[4]));
                  var23.setCreatetime(new Date());
                  var23.setChecknumber("GD-1-3");
                  this.baseNativeSqlRepository.saveAndFlush(var23);
                  resultMap.put("GD-1-3", "2");
                  errorObject1 = new JSONObject();
                  errorObject1.put("checknumber", "GD-1-7");
                  errorObject1.put("xmlcolumn", Convert.toReadStr(var40[3]) + "值与类型不符");
                  errorArray.add(errorObject1);
               }

               if(containsSpecialChars(Convert.toReadStr(var39))) {
                  var23 = new FourCheckDetailPO();
                  var23.setTabuuid(Convert.getUUID());
                  var23.setChecktaskuuid(taskUuid);
                  var23.setXmlflag(Convert.toReadStr(inputval.get("BARCODE")));
                  var23.setXmlcolumn(Convert.toReadStr(var40[3]) + "值包含特殊字符");
                  var23.setXmlcolumn1(Convert.toReadStr(var39));
                  var23.setCreatetime(new Date());
                  var23.setChecknumber("GD-1-3");
                  this.baseNativeSqlRepository.saveAndFlush(var23);
                  resultMap.put("GD-1-6", "2");
                  errorObject1 = new JSONObject();
                  errorObject1.put("checknumber", "GD-1-7");
                  errorObject1.put("xmlcolumn", Convert.toReadStr(var40[3]) + "值包含特殊字符");
                  errorArray.add(errorObject1);
               }
            }
         }

         this.getProxy().updateFourCheckTaskStatus(taskUuid, resultMap);
         if(!resultMap.containsValue("2")) {
            return BizOutput.success(taskUuid);
         } else {
            BizOutput var33 = new BizOutput();
            var33.setStatus(false);
            StringBuffer var35 = new StringBuffer();

            for(int var37 = 0; var37 < errorArray.size(); ++var37) {
               errorObject = errorArray.getJSONObject(var37);
               var35.append(errorObject.get("checknumber") + ":" + errorObject.getString("xmlcolumn")).append(";");
            }

            var33.setErrorMessage("四性检测失败:\n" + var35.toString());
            return var33;
         }
      }
   }

   @DataSource("siitarct")
   public void updateFourCheckTaskStatus(String taskUuid, Map resultMap) throws Exception {
      StringBuffer sql = new StringBuffer();
      sql.append(" UPDATE arct_check_data_task SET ");
      HashMap params = new HashMap();
      Iterator var5 = resultMap.entrySet().iterator();

      while(var5.hasNext()) {
         Entry entry = (Entry)var5.next();
         sql.append(this.convertDbField((String)entry.getKey())).append("=:").append(((String)entry.getKey()).replace("-", "")).append("status, ");
         params.put(((String)entry.getKey()).replace("-", "") + "status", entry.getValue());
      }

      sql.deleteCharAt(sql.length() - 2);
      params.put("tabuuid", taskUuid);
      sql.append(" WHERE TABUUID= :tabuuid");
      this.baseNativeSqlRepository.executeSql(sql.toString(), params);
   }

   private boolean checkDataType(String dataType, Object columnValue) {
      return "Integer".equals(dataType) && !Convert.toReadStr(columnValue).matches("^-?\\d+$")?false:("Long".equals(dataType) && !Convert.toReadStr(columnValue).matches("^-?\\d+$")?false:("Double".equals(dataType) && !Convert.toReadStr(columnValue).matches("^-?\\d+(\\.\\d+)?([eE][-+]?\\d+)?$")?false:!"Date".equals(dataType) || Convert.toReadStr(columnValue).matches("^(\\d{4}-[01]\\d-[0-3]\\d)(?: ([01]\\d|2[0-3]):[0-5]\\d:[0-5]\\d)?$") || columnValue instanceof Date));
   }

   @DataSource("siitarct")
   public boolean checkUnique(Map inputval, String tableName, List uniqueColumn) throws Exception {
      StringBuffer sql = new StringBuffer();
      sql.append("SELECT * FROM ").append(tableName).append(" WHERE 1=1");
      Iterator params = uniqueColumn.iterator();

      while(params.hasNext()) {
         String list = (String)params.next();
         sql.append(" AND ").append(list).append(" = :").append(list);
      }

      HashMap params1 = new HashMap();
      Iterator list1 = uniqueColumn.iterator();

      while(list1.hasNext()) {
         String column = (String)list1.next();
         params1.put(column, inputval.get(column));
      }

      List list2 = this.baseNativeSqlRepository.querySqlList(sql.toString(), params1);
      return list2.size() <= 0;
   }

   public String getTaskUuidByBarcode(String barcode) throws Exception {
      String sql = "SELECT TABUUID FROM arct_check_data_task WHERE BARCODE = :barcode";
      HashMap params = new HashMap();
      params.put("barcode", barcode);
      List list = this.baseNativeSqlRepository.querySqlMap(sql, params);
      return list.size() > 0?Convert.toReadStr(((Map)list.get(0)).get("TABUUID")):"";
   }

   @DataSource("siitarct")
   public BizOutput saveCheckFileResult(byte[] filebytes, String fileName, String barcode, String taskuuid, Map formInfo) throws Exception {
      if(!"1".equals(formInfo.get("isFourCheck"))) {
         return BizOutput.success();
      } else {
         String taskUuid = taskuuid;
         if(Convert.isNullOrEmpty(taskuuid).booleanValue()) {
            taskUuid = this.getProxy().getTaskUuidByBarcode(barcode);
         }

         if(Convert.isNullOrEmpty(taskUuid).booleanValue()) {
            return BizOutput.success();
         } else {
            StringBuffer errorMsg = new StringBuffer();
            HashMap resultMap = new HashMap();
            resultMap.put("GD-1-1", "1");
            resultMap.put("GD-1-10", "1");
            resultMap.put("GD-4-7", "1");
            resultMap.put("GD-4-2", "1");
            resultMap.put("GD-4-1", "1");
            String lastname = fileName.substring(fileName.lastIndexOf(".") + 1);
            String temDir = System.getProperty("java.io.tmpdir");
            String tempDir = temDir + "/verfiyXbrl/" + (new Date()).getTime() + "/" + Convert.getUUID() + "." + lastname;
            String signTempdir = this.configUtils.getConfig("CA_CHECK_PATH");
            File file = new File(tempDir);
            FileUtils.writeByteArrayToFile(file, filebytes);
            if("pdf".equals(lastname.toLowerCase(Locale.ENGLISH)) || "ofd".equals(lastname.toLowerCase(Locale.ENGLISH))) {
               boolean type = true;
               boolean error = true;
               if("ofd".equals(lastname.toLowerCase(Locale.ENGLISH))) {
                  type = FileTypeUtil.getCheckCaToolsofd(signTempdir, tempDir);
               } else {
                  List checkDetail = FileTypeUtil.getCheckCaTools(signTempdir, tempDir);
                  type = ((Boolean)checkDetail.get(1)).booleanValue();
                  error = ((Boolean)checkDetail.get(0)).booleanValue();
               }

               if(error) {
                  if(!type) {
                     FourCheckDetailPO checkDetail1 = new FourCheckDetailPO();
                     checkDetail1.setTabuuid(Convert.getUUID());
                     checkDetail1.setChecknumber("GD-1-1");
                     checkDetail1.setChecktaskuuid(taskUuid);
                     checkDetail1.setXmlcolumn(fileName + "文件签名无效");
                     checkDetail1.setCreatetime(new Date());
                     this.baseNativeSqlRepository.saveAndFlush(checkDetail1);
                     resultMap.put("GD-1-1", "2");
                     errorMsg.append("GD-1-1：文件签名无效;");
                  }
               } else {
                  errorMsg.append("该文件格式为异常，请重新提供;");
               }
            }

            if(file.exists()) {
               file.delete();
            }

            String type1 = FileTypeUtil.getFileType(filebytes, lastname);
            if("3".equals(type1)) {
               FourCheckDetailPO error1 = new FourCheckDetailPO();
               error1.setTabuuid(Convert.getUUID());
               error1.setChecknumber("GD-1-10");
               error1.setChecktaskuuid(taskUuid);
               error1.setXmlcolumn(fileName + "文件头无效");
               error1.setXmlcolumn1(lastname);
               error1.setCreatetime(new Date());
               this.baseNativeSqlRepository.saveAndFlush(error1);
               resultMap.put("GD-1-10", "2");
               errorMsg.append("GD-1-10：文件头无效;");
            }

            this.getProxy().updateDefaultSuccess(taskUuid, fileDefaultSuccess);
            this.getProxy().updateFourCheckTaskStatus(taskUuid, resultMap);
            if(errorMsg.length() > 0) {
               BizOutput error2 = new BizOutput();
               error2.setStatus(false);
               error2.setErrorMessage("四性检测失败:\n" + errorMsg.toString());
               return error2;
            } else {
               return BizOutput.success();
            }
         }
      }
   }

   @DataSource("siitarct")
   public BizOutput saveCheckFileResult(byte[] filebytes, String fileName, String barcode, Map formInfo) throws Exception {
      return this.saveCheckFileResult(filebytes, fileName, barcode, "", formInfo);
   }

   @DataSource("siitarct")
   public String saveFourCheckTask(Map inputval, JSONObject forminfo, String checkType) throws Exception {
      LoginVo user = UserTools.getUser();
      String tabuuid = Convert.getUUID();
      StringBuffer sql = new StringBuffer();
      sql.append(" INSERT INTO arct_check_data_task (TABUUID,FORMUUID,BARCODE,DATAYEAR,DATAMONTH,CREATEBY,CREATETIME,CHECKTYPE)");
      sql.append(" VALUES(:tabuuid,:formuuid,:barcode,:dataYear,:dataMonth,:createBy,:createTime,:checkType)");
      HashMap params = new HashMap();
      params.put("tabuuid", tabuuid);
      params.put("formuuid", Convert.toReadStr(forminfo.getString("tabuuid")));
      params.put("barcode", Convert.toReadStr(inputval.get("BARCODE")));
      params.put("dataYear", Convert.toReadStr(inputval.get("DATAYEAR")));
      params.put("dataMonth", Convert.toReadStr(inputval.get("DATAMONTH")));
      params.put("createBy", user.getUsername());
      params.put("createTime", new Date());
      params.put("checkType", checkType);
      this.baseNativeSqlRepository.executeSql(sql.toString(), params);
      return tabuuid;
   }

   @DataSource("siitarct")
   public String saveBookFourCheckTask(Map inputval, JSONObject forminfo, String checktype) throws Exception {
      LoginVo user = UserTools.getUser();
      String tabuuid = Convert.getUUID();
      StringBuffer sql = new StringBuffer();
      sql.append(" INSERT INTO arct_check_data_task (TABUUID,FORMUUID,BARCODE,DATAYEAR,DATAMONTH,CREATEBY,CREATETIME)");
      sql.append(" VALUES(:tabuuid,:formuuid,:barcode,:dataYear,:dataMonth,:createBy,:createTime)");
      HashMap params = new HashMap();
      params.put("tabuuid", tabuuid);
      params.put("formuuid", Convert.toReadStr(forminfo.getString("tabuuid")));
      params.put("barcode", Convert.toReadStr(inputval.get("BOOK_CODE")));
      params.put("dataYear", Convert.toReadStr(inputval.get("BOOK_YEAR")));
      params.put("dataMonth", Convert.toReadStr(inputval.get("BOOK_PERIOD")));
      params.put("createBy", user.getUsername());
      params.put("createTime", new Date());
      this.baseNativeSqlRepository.executeSql(sql.toString(), params);
      return tabuuid;
   }

   @DataSource("siitarct")
   public void updateDefaultSuccess(String taskUuid, String[] defaultSuccess) throws Exception {
      StringBuffer sql = new StringBuffer();
      sql.append(" UPDATE arct_check_data_task SET ");
      HashMap params = new HashMap();

      for(int i = 0; i < defaultSuccess.length; ++i) {
         sql.append(this.convertDbField(defaultSuccess[i])).append(" = :status, ");
         if(i == defaultSuccess.length - 1) {
            sql.deleteCharAt(sql.length() - 2);
         }
      }

      params.put("status", "1");
      params.put("tabuuid", taskUuid);
      sql.append(" WHERE TABUUID= :tabuuid");
      this.baseNativeSqlRepository.executeSql(sql.toString(), params);
   }

   private String convertDbField(String field) {
      if(SIITDBType.IsMysql()) {
         field = '`' + field + '`';
      }

      return field;
   }

   public FourCheckService getProxy() {
      return (FourCheckService)SpringContextUtils.getApplication().getBean(FourCheckService.class);
   }

   @DataSource("siitarct")
   public PageView queryPageView(PageView page) throws Exception {
      StringBuffer sql = new StringBuffer();
      sql.append(" SELECT * FROM arct_check_data_task WHERE 1=1");
      HashMap params = new HashMap();
      if(!Convert.isNullOrEmpty(((Map)page.getModel()).get("formuuid")).booleanValue()) {
         sql.append(" AND FORMUUID = :formuuid");
         params.put("formuuid", ((Map)page.getModel()).get("formuuid"));
      }

      if(!Convert.isNullOrEmpty(((Map)page.getModel()).get("barcode")).booleanValue()) {
         sql.append(" AND BARCODE = :barcode");
         params.put("barcode", ((Map)page.getModel()).get("barcode"));
      }

      if(!Convert.isNullOrEmpty(((Map)page.getModel()).get("dataYear")).booleanValue()) {
         sql.append(" AND DATAYEAR = :dataYear");
         params.put("dataYear", ((Map)page.getModel()).get("dataYear"));
      }

      if(!Convert.isNullOrEmpty(((Map)page.getModel()).get("dataMonth")).booleanValue()) {
         sql.append(" AND DATAMONTH = :dataMonth");
         params.put("dataMonth", ((Map)page.getModel()).get("dataMonth"));
      }

      if(!Convert.isNullOrEmpty(((Map)page.getModel()).get("createBy")).booleanValue()) {
         sql.append(" AND CREATEBY = :createBy");
         params.put("createBy", ((Map)page.getModel()).get("createBy"));
      }

      if(!Convert.isNullOrEmpty(((Map)page.getModel()).get("createTimeStart")).booleanValue()) {
         sql.append(" AND CREATETIME >= :createTimeStart");
         params.put("createTimeStart", ((Map)page.getModel()).get("createTimeStart"));
      }

      if(!Convert.isNullOrEmpty(((Map)page.getModel()).get("createTimeEnd")).booleanValue()) {
         sql.append(" AND CREATETIME <= :createTimeEnd");
         params.put("createTimeEnd", ((Map)page.getModel()).get("createTimeEnd"));
      }

      String countSql = "SELECT COUNT(*) FROM ( " + sql.toString() + " ) AS t";
      sql.append(" ORDER BY CREATETIME desc");
      PageView pageView = this.baseNativeSqlRepository.getMapPageBySql(sql.toString(), countSql, params, page.getCurrPage(), page.getPageSize());
      return pageView;
   }

}
